(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common/http'), require('@angular/forms'), require('@angular/router'), require('ngx-toastr'), require('@angular/platform-browser/animations'), require('@angular/common'), require('rxjs')) :
    typeof define === 'function' && define.amd ? define('wh-library', ['exports', '@angular/core', '@angular/common/http', '@angular/forms', '@angular/router', 'ngx-toastr', '@angular/platform-browser/animations', '@angular/common', 'rxjs'], factory) :
    (global = global || self, factory(global['wh-library'] = {}, global.ng.core, global.ng.common.http, global.ng.forms, global.ng.router, global.ngxToastr, global.ng.platformBrowser.animations, global.ng.common, global.rxjs));
}(this, (function (exports, core, http, forms, router, ngxToastr, animations, common, rxjs) { 'use strict';

    var LoggedUser = /** @class */ (function () {
        function LoggedUser() {
        }
        return LoggedUser;
    }());

    var EnvironmentToken = new core.InjectionToken('config');
    var LibraryEnvironment = /** @class */ (function () {
        function LibraryEnvironment() {
        }
        return LibraryEnvironment;
    }());

    var LoginService = /** @class */ (function () {
        function LoginService(environment, http) {
            this.environment = environment;
            this.http = http;
            this.loggedUser = new LoggedUser();
        }
        LoginService.prototype.login = function (credentials) {
            var url = this.environment.warehouseApi + "/login";
            return this.http.post(url, credentials);
        };
        LoginService.ɵfac = function LoginService_Factory(t) { return new (t || LoginService)(core.ɵɵinject(EnvironmentToken), core.ɵɵinject(http.HttpClient)); };
        LoginService.ɵprov = core.ɵɵdefineInjectable({ token: LoginService, factory: LoginService.ɵfac, providedIn: 'root' });
        return LoginService;
    }());
    /*@__PURE__*/ (function () { core.ɵsetClassMetadata(LoginService, [{
            type: core.Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], function () { return [{ type: LibraryEnvironment, decorators: [{
                    type: core.Inject,
                    args: [EnvironmentToken]
                }] }, { type: http.HttpClient }]; }, null); })();

    var ErrorPageComponent = /** @class */ (function () {
        function ErrorPageComponent() {
        }
        ErrorPageComponent.prototype.ngOnInit = function () {
        };
        ErrorPageComponent.ɵfac = function ErrorPageComponent_Factory(t) { return new (t || ErrorPageComponent)(); };
        ErrorPageComponent.ɵcmp = core.ɵɵdefineComponent({ type: ErrorPageComponent, selectors: [["lib-error-page"]], decls: 2, vars: 0, template: function ErrorPageComponent_Template(rf, ctx) { if (rf & 1) {
                core.ɵɵelementStart(0, "p");
                core.ɵɵtext(1, "error-page works!");
                core.ɵɵelementEnd();
            } }, styles: [""] });
        return ErrorPageComponent;
    }());
    /*@__PURE__*/ (function () { core.ɵsetClassMetadata(ErrorPageComponent, [{
            type: core.Component,
            args: [{
                    selector: 'lib-error-page',
                    templateUrl: './error-page.component.html',
                    styleUrls: ['./error-page.component.css']
                }]
        }], function () { return []; }, null); })();

    var NotificationService = /** @class */ (function () {
        function NotificationService(toastr) {
            this.toastr = toastr;
        }
        NotificationService.prototype.notify = function (message) {
            alert(message);
        };
        NotificationService.prototype.successmsg = function (message) {
            this.toastr.success(message, 'Success');
        };
        NotificationService.prototype.errorsmsg = function (message) {
            this.toastr.error(message, 'Error');
        };
        NotificationService.prototype.infotoastr = function (message) {
            this.toastr.info(message, 'Information');
        };
        NotificationService.prototype.toastrwaring = function (message) {
            this.toastr.warning(message, 'Warning');
        };
        NotificationService.ɵfac = function NotificationService_Factory(t) { return new (t || NotificationService)(core.ɵɵinject(ngxToastr.ToastrService)); };
        NotificationService.ɵprov = core.ɵɵdefineInjectable({ token: NotificationService, factory: NotificationService.ɵfac, providedIn: 'root' });
        return NotificationService;
    }());
    /*@__PURE__*/ (function () { core.ɵsetClassMetadata(NotificationService, [{
            type: core.Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], function () { return [{ type: ngxToastr.ToastrService }]; }, null); })();

    var ErrorHandlerService = /** @class */ (function () {
        function ErrorHandlerService(notify) {
            this.notify = notify;
        }
        ErrorHandlerService.prototype.handleError = function (response) {
            if (response.status === 0) {
                this.notify.errorsmsg('Server nije dostupan.');
            }
            else if (response.status === 400) {
                this.notify.errorsmsg(response.error + ".");
            }
        };
        ErrorHandlerService.ɵfac = function ErrorHandlerService_Factory(t) { return new (t || ErrorHandlerService)(core.ɵɵinject(NotificationService)); };
        ErrorHandlerService.ɵprov = core.ɵɵdefineInjectable({ token: ErrorHandlerService, factory: ErrorHandlerService.ɵfac, providedIn: 'root' });
        return ErrorHandlerService;
    }());
    /*@__PURE__*/ (function () { core.ɵsetClassMetadata(ErrorHandlerService, [{
            type: core.Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], function () { return [{ type: NotificationService }]; }, null); })();

    var LoginComponent = /** @class */ (function () {
        function LoginComponent(formBuilder, loginService, router, errorHandlerService) {
            this.formBuilder = formBuilder;
            this.loginService = loginService;
            this.router = router;
            this.errorHandlerService = errorHandlerService;
            this.loginForm = this.formBuilder.group({
                username: new forms.FormControl('', [forms.Validators.required]),
                password: new forms.FormControl('', [forms.Validators.required])
            });
        }
        LoginComponent.prototype.ngOnInit = function () {
            this.operaterAuthenticated();
        };
        LoginComponent.prototype.submit = function () {
            var _this = this;
            var loginCerdentials = {
                username: this.loginForm.controls.username.value,
                password: this.loginForm.controls.password.value
            };
            this.loginService.login(loginCerdentials).subscribe(function (loggedUser) {
                _this.loginService.loggedUser = loggedUser;
                _this.operaterAuthenticated();
            }, function (error) {
                _this.errorHandlerService.handleError(error);
            });
        };
        LoginComponent.prototype.operaterAuthenticated = function () {
            if (this.loginService.loggedUser.guid) {
                this.router.navigate(['dashboard', 'landing-page']);
            }
        };
        LoginComponent.ɵfac = function LoginComponent_Factory(t) { return new (t || LoginComponent)(core.ɵɵdirectiveInject(forms.FormBuilder), core.ɵɵdirectiveInject(LoginService), core.ɵɵdirectiveInject(router.Router), core.ɵɵdirectiveInject(ErrorHandlerService)); };
        LoginComponent.ɵcmp = core.ɵɵdefineComponent({ type: LoginComponent, selectors: [["app-login"]], decls: 14, vars: 1, consts: [["autocomplete", "off", 3, "formGroup", "ngSubmit"], [1, "flexbox-column-container", "jumbotron"], ["for", "username", 1, "flexbox-label"], ["type", "text", "formControlName", "username", 1, "flexbox-item"], ["for", "password", 1, "flexbox-label"], ["type", "password", "formControlName", "password", 1, "flexbox-item"], [1, "flexbox-label"], ["type", "submit", 1, "btn", "btn-primary", "flexbox-item"]], template: function LoginComponent_Template(rf, ctx) { if (rf & 1) {
                core.ɵɵelementStart(0, "form", 0);
                core.ɵɵlistener("ngSubmit", function LoginComponent_Template_form_ngSubmit_0_listener() { return ctx.submit(); });
                core.ɵɵelementStart(1, "div", 1);
                core.ɵɵelementStart(2, "div");
                core.ɵɵelementStart(3, "label", 2);
                core.ɵɵtext(4, "Username: ");
                core.ɵɵelementEnd();
                core.ɵɵelement(5, "input", 3);
                core.ɵɵelementEnd();
                core.ɵɵelementStart(6, "div");
                core.ɵɵelementStart(7, "label", 4);
                core.ɵɵtext(8, "Password: ");
                core.ɵɵelementEnd();
                core.ɵɵelement(9, "input", 5);
                core.ɵɵelementEnd();
                core.ɵɵelementStart(10, "div");
                core.ɵɵelement(11, "label", 6);
                core.ɵɵelementStart(12, "button", 7);
                core.ɵɵtext(13, "Login");
                core.ɵɵelementEnd();
                core.ɵɵelementEnd();
                core.ɵɵelementEnd();
                core.ɵɵelementEnd();
            } if (rf & 2) {
                core.ɵɵproperty("formGroup", ctx.loginForm);
            } }, directives: [forms.ɵangular_packages_forms_forms_y, forms.NgControlStatusGroup, forms.FormGroupDirective, forms.DefaultValueAccessor, forms.NgControlStatus, forms.FormControlName], styles: [""] });
        return LoginComponent;
    }());
    /*@__PURE__*/ (function () { core.ɵsetClassMetadata(LoginComponent, [{
            type: core.Component,
            args: [{
                    selector: 'app-login',
                    templateUrl: './login.component.html',
                    styleUrls: ['./login.component.css']
                }]
        }], function () { return [{ type: forms.FormBuilder }, { type: LoginService }, { type: router.Router }, { type: ErrorHandlerService }]; }, null); })();

    var NavbarComponent = /** @class */ (function () {
        function NavbarComponent(loginService) {
            this.loginService = loginService;
        }
        Object.defineProperty(NavbarComponent.prototype, "userName", {
            get: function () {
                return this.loginService.loggedUser.name;
            },
            enumerable: true,
            configurable: true
        });
        NavbarComponent.ɵfac = function NavbarComponent_Factory(t) { return new (t || NavbarComponent)(core.ɵɵdirectiveInject(LoginService)); };
        NavbarComponent.ɵcmp = core.ɵɵdefineComponent({ type: NavbarComponent, selectors: [["lib-navbar"]], decls: 2, vars: 1, consts: [[1, "mr-5", 2, "text-align", "end", "height", "50px"]], template: function NavbarComponent_Template(rf, ctx) { if (rf & 1) {
                core.ɵɵelementStart(0, "div", 0);
                core.ɵɵtext(1);
                core.ɵɵelementEnd();
            } if (rf & 2) {
                core.ɵɵadvance(1);
                core.ɵɵtextInterpolate1(" ", ctx.userName, "\n");
            } }, encapsulation: 2 });
        return NavbarComponent;
    }());
    /*@__PURE__*/ (function () { core.ɵsetClassMetadata(NavbarComponent, [{
            type: core.Component,
            args: [{
                    selector: 'lib-navbar',
                    templateUrl: './navbar.component.html',
                }]
        }], function () { return [{ type: LoginService }]; }, null); })();

    var NavigationComponent = /** @class */ (function () {
        function NavigationComponent(location) {
            this.location = location;
        }
        NavigationComponent.prototype.ngOnInit = function () {
        };
        NavigationComponent.prototype.goBack = function () {
            this.location.back();
        };
        NavigationComponent.ɵfac = function NavigationComponent_Factory(t) { return new (t || NavigationComponent)(core.ɵɵdirectiveInject(common.Location)); };
        NavigationComponent.ɵcmp = core.ɵɵdefineComponent({ type: NavigationComponent, selectors: [["lib-navigation"]], decls: 1, vars: 0, consts: [[3, "click"]], template: function NavigationComponent_Template(rf, ctx) { if (rf & 1) {
                core.ɵɵelementStart(0, "button", 0);
                core.ɵɵlistener("click", function NavigationComponent_Template_button_click_0_listener() { return ctx.goBack(); });
                core.ɵɵelementEnd();
            } }, styles: [""] });
        return NavigationComponent;
    }());
    /*@__PURE__*/ (function () { core.ɵsetClassMetadata(NavigationComponent, [{
            type: core.Component,
            args: [{
                    selector: 'lib-navigation',
                    templateUrl: './navigation.component.html',
                    styleUrls: ['./navigation.component.css']
                }]
        }], function () { return [{ type: common.Location }]; }, null); })();

    var WhLibraryModule = /** @class */ (function () {
        function WhLibraryModule() {
        }
        WhLibraryModule.forRoot = function (environment) {
            return {
                ngModule: WhLibraryModule,
                providers: [
                    {
                        provide: EnvironmentToken,
                        useValue: environment
                    }
                ]
            };
        };
        WhLibraryModule.ɵmod = core.ɵɵdefineNgModule({ type: WhLibraryModule });
        WhLibraryModule.ɵinj = core.ɵɵdefineInjector({ factory: function WhLibraryModule_Factory(t) { return new (t || WhLibraryModule)(); }, providers: [
                LoginService
            ], imports: [[
                    http.HttpClientModule,
                    forms.ReactiveFormsModule,
                    animations.BrowserAnimationsModule,
                    ngxToastr.ToastrModule.forRoot({
                        timeOut: 5000,
                        positionClass: 'toast-bottom-full-width',
                        preventDuplicates: true,
                    })
                ]] });
        return WhLibraryModule;
    }());
    (function () { (typeof ngJitMode === "undefined" || ngJitMode) && core.ɵɵsetNgModuleScope(WhLibraryModule, { declarations: [LoginComponent,
            ErrorPageComponent,
            NavbarComponent,
            NavigationComponent], imports: [http.HttpClientModule,
            forms.ReactiveFormsModule,
            animations.BrowserAnimationsModule, ngxToastr.ToastrModule], exports: [LoginComponent,
            NavbarComponent] }); })();
    /*@__PURE__*/ (function () { core.ɵsetClassMetadata(WhLibraryModule, [{
            type: core.NgModule,
            args: [{
                    declarations: [
                        LoginComponent,
                        ErrorPageComponent,
                        NavbarComponent,
                        NavigationComponent
                    ],
                    imports: [
                        http.HttpClientModule,
                        forms.ReactiveFormsModule,
                        animations.BrowserAnimationsModule,
                        ngxToastr.ToastrModule.forRoot({
                            timeOut: 5000,
                            positionClass: 'toast-bottom-full-width',
                            preventDuplicates: true,
                        })
                    ],
                    providers: [
                        LoginService
                    ],
                    exports: [
                        LoginComponent,
                        NavbarComponent
                    ]
                }]
        }], null, null); })();

    var AccessGuard = /** @class */ (function () {
        function AccessGuard(loginService, router) {
            this.loginService = loginService;
            this.router = router;
        }
        AccessGuard.prototype.canActivate = function () {
            if (this.loginService.loggedUser.guid) {
                return rxjs.of(true);
            }
            this.router.navigate(['login']);
            return rxjs.of(false);
        };
        AccessGuard.ɵfac = function AccessGuard_Factory(t) { return new (t || AccessGuard)(core.ɵɵinject(LoginService), core.ɵɵinject(router.Router)); };
        AccessGuard.ɵprov = core.ɵɵdefineInjectable({ token: AccessGuard, factory: AccessGuard.ɵfac, providedIn: 'root' });
        return AccessGuard;
    }());
    /*@__PURE__*/ (function () { core.ɵsetClassMetadata(AccessGuard, [{
            type: core.Injectable,
            args: [{
                    providedIn: 'root',
                }]
        }], function () { return [{ type: LoginService }, { type: router.Router }]; }, null); })();

    var HelperService = /** @class */ (function () {
        function HelperService() {
        }
        HelperService.prototype.unsubscribeSubscriptions = function (subscriptions) {
            subscriptions.forEach(function (x) {
                if (x) {
                    x.unsubscribe();
                }
            });
        };
        HelperService.ɵfac = function HelperService_Factory(t) { return new (t || HelperService)(); };
        HelperService.ɵprov = core.ɵɵdefineInjectable({ token: HelperService, factory: HelperService.ɵfac, providedIn: 'root' });
        return HelperService;
    }());
    /*@__PURE__*/ (function () { core.ɵsetClassMetadata(HelperService, [{
            type: core.Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], null, null); })();

    var Login = /** @class */ (function () {
        function Login() {
        }
        return Login;
    }());

    var Category = /** @class */ (function () {
        function Category() {
        }
        return Category;
    }());

    var Engine = /** @class */ (function () {
        function Engine() {
        }
        return Engine;
    }());

    var Manufacturer = /** @class */ (function () {
        function Manufacturer() {
        }
        return Manufacturer;
    }());

    var Model = /** @class */ (function () {
        function Model() {
        }
        return Model;
    }());

    var SubCategory = /** @class */ (function () {
        function SubCategory() {
        }
        return SubCategory;
    }());

    var OrderStatus = /** @class */ (function () {
        function OrderStatus() {
        }
        return OrderStatus;
    }());

    var SubCategoryPart = /** @class */ (function () {
        function SubCategoryPart() {
        }
        return SubCategoryPart;
    }());

    var PartDetails = /** @class */ (function () {
        function PartDetails() {
        }
        return PartDetails;
    }());

    var Identified = /** @class */ (function () {
        function Identified() {
            this.identifiedModel = new IdentifiedModel();
            this.identifiedPart = new IdentifiedPart();
        }
        return Identified;
    }());
    var IdentifiedModel = /** @class */ (function () {
        function IdentifiedModel() {
        }
        return IdentifiedModel;
    }());
    var IdentifiedPart = /** @class */ (function () {
        function IdentifiedPart() {
        }
        return IdentifiedPart;
    }());

    var CommunicationDelay = /** @class */ (function () {
        function CommunicationDelay() {
        }
        CommunicationDelay.delay1sec = 1000;
        CommunicationDelay.delay2sec = 2000;
        CommunicationDelay.delay5sec = 5000;
        return CommunicationDelay;
    }());

    var Helper = /** @class */ (function () {
        function Helper() {
        }
        Helper.isNumber = function (value) {
            return value != null && value !== '' && !isNaN(Number(value.toString()));
        };
        Helper.isLocation = function (qrCode) {
            var numberOfWords = qrCode.split(' ');
            return numberOfWords.length === 6;
        };
        return Helper;
    }());

    exports.AccessGuard = AccessGuard;
    exports.Category = Category;
    exports.CommunicationDelay = CommunicationDelay;
    exports.Engine = Engine;
    exports.ErrorHandlerService = ErrorHandlerService;
    exports.Helper = Helper;
    exports.HelperService = HelperService;
    exports.Identified = Identified;
    exports.IdentifiedModel = IdentifiedModel;
    exports.IdentifiedPart = IdentifiedPart;
    exports.LoggedUser = LoggedUser;
    exports.Login = Login;
    exports.LoginComponent = LoginComponent;
    exports.LoginService = LoginService;
    exports.Manufacturer = Manufacturer;
    exports.Model = Model;
    exports.NavbarComponent = NavbarComponent;
    exports.NavigationComponent = NavigationComponent;
    exports.NotificationService = NotificationService;
    exports.OrderStatus = OrderStatus;
    exports.PartDetails = PartDetails;
    exports.SubCategory = SubCategory;
    exports.SubCategoryPart = SubCategoryPart;
    exports.WhLibraryModule = WhLibraryModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=wh-library.umd.js.map
